## re2c-4.3-1.src.tar.zst

=== doc/papers/2020_re2c_a_lexer_generator_based_on_lookahead_tdfa/Makefile ===
2020_trofimovich_re2c_a_lexer_generator_based_on_lookahead_tdfa.pdf : 2020_trofimovich_re2c_a_lexer_generator_based_on_lookahead_tdfa.tex example.pdf
	pdflatex -shell-escape $< </dev/null > $<.log

example.pdf : example.tex
	lualatex -shell-escape $< </dev/null > $<.build_log

clean:
	rm -f *.log *.pdf *.build_log *.aux *.out *.spl

=== benchmarks/c/libre2c/java/CMakeLists.txt ===
find_package(Java)
find_package(JNI)
if (Java_FOUND AND JNI_FOUND)
    include(UseJava)

    # Java bindings to libre2c.
    # Generate header for libre2c_jni.
    add_jar(RE2C
        libre2c/RE2C.java
        GENERATE_NATIVE_HEADERS RE2C-native
        ENTRY_POINT re2c.RE2C
    )

    # Build libre2c_jni.
    add_library(re2c_jni SHARED libre2c/RE2C.cpp)
    target_include_directories(re2c_jni PRIVATE "${CMAKE_SOURCE_DIR}/lib")
    target_link_libraries(re2c_jni RE2C-native libre2c_shared)

    # Build ReTdfa library and the benchmark.
    add_jar(ReTdfa
        ReTdfa.java
        INCLUDE_JARS RE2C
        ENTRY_POINT ReTdfa
    )

    # Python script that runs the benchmark.
    set(builddir ".")
    configure_file(run.py.in run.py @ONLY)

    # Benchmark input data.
    set(samples "samples.ser")
    file(ARCHIVE_EXTRACT
        INPUT "${CMAKE_CURRENT_SOURCE_DIR}/${samples}.zip"
    )

    # JS chart for the benchmark results.
    set(js_chart "chart.js")
    configure_file("${js_chart}" "${js_chart}" COPYONLY)

    # Cleanup.
    set_directory_properties(PROPERTY
        ADDITIONAL_CLEAN_FILES "${samples};${js_chart}"
    )
endif()

=== benchmarks/c/libre2c/nfa/CMakeLists.txt ===
add_executable(bench_submatch_nfa
    "bench.cc"
    "${CMAKE_SOURCE_DIR}/benchmarks/c/common/common.cc"
)

target_link_libraries(bench_submatch_nfa libre2c)

find_package(benchmark REQUIRED)
target_link_libraries(bench_submatch_nfa benchmark::benchmark)

# if present, re2 is used for benchmarks
find_path(RE2_INCLUDE_DIRECTORY "re2/re2.h")
find_library(RE2_LIBRARY re2)
if(RE2_INCLUDE_DIRECTORY AND RE2_LIBRARY)
    set_target_properties(bench_submatch_nfa PROPERTIES
        CXX_STANDARD 17
        CXX_STANDARD_REQUIRED ON)
    target_compile_definitions(bench_submatch_nfa PRIVATE "HAVE_RE2_RE2_H=1")
    target_include_directories(bench_submatch_nfa PRIVATE "${RE2_INCLUDE_DIRECTORY}")
    target_link_libraries(bench_submatch_nfa "${RE2_LIBRARY}")
endif()

=== PKGBUILD ===
# Maintainer: J. Peter Mugaas <jpmugaas@suddenlink.net>
# stolen from Archlinux

pkgname=re2c
pkgver=4.3
pkgrel=1
arch=('i686' 'x86_64')
pkgdesc='A tool for generating C-based recognizers from regular expressions'
url='https://re2c.org/'
msys2_repository_url="https://github.com/skvadrik/re2c"
msys2_references=(
  "anitya: 7664"
  "cpe: cpe:/a:re2c:re2c"
)
license=('public domain')
depends=('gcc-libs')
makedepends=('cmake' 'gcc' 'python' 'ninja')
source=(${pkgname}-${pkgver}.tar.gz::https://github.com/skvadrik/re2c/archive/${pkgver}.tar.gz)
sha256sums=('39cd7048a817cf3d7d0c2e58a52fb3597d6e1bc86b1df32b8a3cd755c458adfd')

build() {
  cd ${pkgname}-${pkgver}
  cmake -GNinja -B build -DCMAKE_INSTALL_PREFIX=/usr
  cmake --build build
}

check() {
  cd ${pkgname}-${pkgver}
  cmake --build build --target check
}

package() {
  cd ${pkgname}-${pkgver}
  DESTDIR="${pkgdir}" cmake --install build
  install -Dm644 LICENSE ${pkgdir}/usr/share/licenses/${pkgname}/LICENSE
}
